#Boa:Frame:mainf
# _*_ coding: iso-8859-15 _*_


import wx, os
from twisted.internet import threads, reactor
from win32api import GetComputerName
from sys import exit, argv

from manage_inst import cliScribeInst


def create(parent):
    return mainf(parent)

[wxID_MAINF, wxID_MAINFBUTTONDESINST, wxID_MAINFBUTTONINST, 
 wxID_MAINFSTATUSBAR, 
] = [wx.NewId() for _init_ctrls in range(4)]

[wxID_MAINFMENUFICHIERQUITTER] = [wx.NewId() for _init_coll_menuFichier_Items in range(1)]

class mainf(wx.Frame):
    def _init_coll_menuBar_Menus(self, parent):
        # generated method, don't edit

        parent.Append(menu=self.menuFichier, title='Fichier')

    def _init_coll_menuFichier_Items(self, parent):
        # generated method, don't edit

        parent.Append(help='', id=wxID_MAINFMENUFICHIERQUITTER,
              kind=wx.ITEM_NORMAL, text='Quitter')
        self.Bind(wx.EVT_MENU, self.OnMenuFichierQuitterMenu,
              id=wxID_MAINFMENUFICHIERQUITTER)

    def _init_utils(self):
        # generated method, don't edit
        self.menuFichier = wx.Menu(title='')

        self.menuBar = wx.MenuBar()

        self._init_coll_menuFichier_Items(self.menuFichier)
        self._init_coll_menuBar_Menus(self.menuBar)

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Frame.__init__(self, ##style=wx.DEFAULT_FRAME_STYLE, id=wxID_MAINF,
              name='mainf', parent=prnt, pos=wx.Point(390, 330),
              size=wx.Size(372, 173),
              style=wx.SYSTEM_MENU | wx.CLIP_CHILDREN | wx.CAPTION | wx.CLOSE_BOX,
              title='Installation Client Scribe')
        self._init_utils()
        self.SetClientSize(wx.Size(364, 139))
        self.SetBackgroundColour(wx.Colour(255, 255, 209))
        self.SetMenuBar(self.menuBar)
        self.SetIcon(wx.Icon('eole.ico',wx.BITMAP_TYPE_ICO))
        self.Center(wx.BOTH)
        self.Bind(wx.EVT_CLOSE, self.OnMainfClose)

        self.statusBar = wx.StatusBar(id=wxID_MAINFSTATUSBAR, name='statusBar',
              parent=self, style=0)
        self.statusBar.SetStatusText(u'Prt')
        self.SetStatusBar(self.statusBar)

        self.buttonInst = wx.Button(id=wxID_MAINFBUTTONINST, label='Installer',
              name='buttonInst', parent=self, pos=wx.Point(72, 32),
              size=wx.Size(75, 23), style=0)
        self.buttonInst.SetThemeEnabled(True)
        self.buttonInst.Bind(wx.EVT_BUTTON, self.OnButtonInstButton,
              id=wxID_MAINFBUTTONINST)

        self.buttonDesInst = wx.Button(id=wxID_MAINFBUTTONDESINST,
              label='D\xe9sinstaller', name='buttonDesInst', parent=self,
              pos=wx.Point(216, 32), size=wx.Size(75, 23), style=0)
        self.buttonDesInst.SetThemeEnabled(True)
        self.buttonDesInst.Bind(wx.EVT_BUTTON, self.OnButtonDesInstButton,
              id=wxID_MAINFBUTTONDESINST)

    def __init__(self, parent):
        self._init_ctrls(parent)
        self.init_vars()

    def init_vars(self):
        if ' ' in GetComputerName():
            message = """Le nom de cette machine doit tre sans espace.
Veuillez le corriger avant de reprendre l'installation."""
            self.pop_message(message, 'erreur')
            exit(1)
        self.silent = False
        self.debug = False
        if '-s' in argv[1:]: self.silent = True
        if '-d' in argv[1:]: self.debug = True
        if '-i' in argv[1:]: self.install()
        elif '-u' in argv[1:]: self.uninstall()

    def OnButtonInstButton(self, event):
        self.install()

    def install(self):
        d = threads.deferToThread(self.lance_install)
        d.addCallback(self.return_inst)
        if not self.debug:
            d.addErrback(self.return_err_inst)

    def lance_install(self):
        self.buttonInst.Disable()
        self.buttonDesInst.Disable()
        self.menuBar.Disable()
        self.statusBar.SetStatusText(u"Installation en cours ...",0)
        self.c = cliScribeInst(self)
        #dsintallation de l'existant
        try: self.c.uninstall(self.silent)
        except: pass
        #installation
        self.c.install(self.silent)

    def OnButtonDesInstButton(self, event):
        self.uninstall()

    def uninstall(self):
        d = threads.deferToThread(self.lance_uninstall)
        d.addCallback(self.return_inst)
        if not self.debug:
            d.addErrback(self.return_err_inst)
    
    def lance_uninstall(self):
        self.buttonInst.Disable()
        self.buttonDesInst.Disable()
        self.menuBar.Disable()
        self.statusBar.SetStatusText(u"Dsinstallation en cours ...",0)
        self.c = cliScribeInst(self)
        self.c.uninstall(self.silent)
        #finalisation
    
    def return_inst(self, ret=True):
        #finalisation
        if self.silent: self.c.RebootServer()
        self.statusBar.SetStatusText(u"Redmarrage ncessaire",0)
        texte = "Redmarrage ncessaire. Voulez-vous l'effectuer maintenant ?"
        val = self.pop_message(texte, 'question')
        if val == wx.ID_YES: self.c.RebootServer()
        self.buttonInst.Enable()
        self.buttonDesInst.Enable()
        reactor.stop()
    
    def return_err_inst(self, ret=True):
        try: mes = str(ret.value)
        except: mes = 'Erreur'
        self.pop_message(mes, 'erreur')
        self.statusBar.SetStatusText(u"Erreur : %s"%mes,0)
            
    def OnMainfClose(self, event):
        reactor.stop()

    def OnMenuFichierQuitterMenu(self, event):
        reactor.stop()

    def pop_message(self, texte, genre):
        if genre.lower() == 'erreur':
            titre = 'Erreur'
            icone = wx.OK | wx.ICON_ERROR
        elif genre.lower() == 'information':
            titre = 'Information'
            icone = wx.OK | wx.ICON_INFORMATION
        elif genre.lower() == 'question':
            titre = 'Question'
            icone = wx.YES_NO | wx.ICON_QUESTION
        dlg = wx.MessageDialog(self, texte, titre, icone)
        try:
            val = dlg.ShowModal()
        finally:
            dlg.Destroy()
        return val
