# _*_ coding: iso-8859-1 _*_
###########################################
## Gnration du service client SCRIBE   ##
## pour la gestion du poste              ##
## licence GPL Eole                      ##
###########################################

from twisted.spread import pb
from twisted.internet import reactor

from platform import release
from logging.handlers import RotatingFileHandler
from time import sleep

import win32api as wa
import win32con as wc

##from killProcName import killProcName
from process import killProcName

import ntsecuritycon as ntsec
import win32serviceutil as wsu


import os
import subprocess
import logging
import shutil
import urllib2, md5
import _winreg

from reg import menu_template, get_option, load_reg
from vnc import Vnc
from perms import AdjustPrivilege
import lecteur

# utilisation du reacteur Windoz
reactortype = "win32"

# dfinition du service
nom = "servscribe"
libelle = "Service Scribe"
version = "3.1"


class servFactory(pb.PBServerFactory):
    def buildProtocol(self, addr):
        #il s'agit d'une liste, il faut faire un "eval"
        ip_list = eval(get_option(r'Software\Eole\Scribe', 'ip_access_list'))
        if str(addr.host) not in ip_list: return None
        return pb.PBServerFactory.buildProtocol(self, addr)

class Echoer(pb.Root):
    """Classe contenant toutes les fonctions distantes
       que le serveur Scribe peut appeler
    """

    def __init__(self, parent):
        """initialisation du fichier de log
        """
        self.log = parent.log
        self.serveur = parent.serveur
        self.user_port = int(get_option(r'Software\Eole\Scribe', 'port_utilisateur'))
        self.http_port = int(get_option(r'Software\Eole\Scribe', 'port_scribe_update'))
        self.http_path = 'http://%s:%s/applications'%(self.serveur, self.http_port)
        # repertoire d'installation
        self.inst_path = get_option(r'Software\Eole\Scribe', 'inst_path')
        # repertoire d'installation vnc
        self.vnc_path = os.path.join(self.inst_path, 'ultravnc')
        # Variables d'environnement
        self.tmpdir = parent.tmpdir
        self.windir = parent.windir
        self.vnc = Vnc(self.vnc_path, self.tmpdir)
        self.nodrives, self.noview = None, None
        # type d'OS
        self.type_os = release().lower()
        if self.type_os in ['xp', '2000']:
            self.type_os = 'xp'
        elif self.type_os in ['95', '98', 'me']:
            self.type_os = '9x'
        AdjustPrivilege([ntsec.SE_SHUTDOWN_NAME, ntsec.SE_BACKUP_NAME])
        
    #######################
    # Fonctions distantes #
    #######################
    def remote_regedit(self, reg_dict):
        """Fonction appliquant les cls de registres dfinies dans regliste
            l'utilisateur dont le SID est pass en paramtre
           regliste = [{'type_variable' : CHAINE/DWORD, 'chemin' : y, 'variable' : z, 'valeur' : }, ...]
           
           EX. : reg_dict = { hkey : 'HKEY_...', <=  valer
                              keypath : 'Software\\Eole', 
                              keyname : 'test_key', 
                              keytype : 'REG_DWORD, <=  valer
                              value : 'SUPPR'} <= supprime la cl
        """
        self.log.info("fonction regedit appelee pour %s"%reg_dict)
        # connexion  hkey
        hkey = getattr(_winreg, reg_dict['hkey'])
        hk = _winreg.ConnectRegistry(None, hkey)
        ktype = getattr(_winreg, reg_dict['keytype'])
        kpath, kname, kval = reg_dict['keypath'], reg_dict['keyname'], reg_dict['value']
        # on attend que hk\reg_dict['keypath'] soit cr
        for test in range(300):
            try:
                key = _winreg.OpenKey(hk, kpath)
                _winreg.CloseKey(key)
                break
            except:
                if (test%10 == 0) : self.log.info("Attente creation entree : %s"%str(test+1))
                sleep(0.1)
        if kval == 'SUPPR':
            ret = self.delreg(hk, kpath, kname)
        else:
            ret = self.addreg(hk, kpath, ktype, kname, kval)
        # dconnexion de HKEY_
        _winreg.CloseKey(hk)
        return ret
    
    def delreg(self, hkey, path, name):
        """Supprime la valeur name dans path
        """
        try:
            k = _winreg.OpenKey(hkey, path, 0, _winreg.KEY_ALL_ACCESS)
            _winreg.DeleteValue(k, name)
            k.Close()
        except: pass
    
    def addreg(self, hk, kpath, ktype, kname, kval):
        """renseigne hkey\path name(type)=value dans la base de registre
        hkey = handle d'une cl ouverte
        """
        try:
            key = _winreg.CreateKey(hk, kpath)
            # SetValueEx attend un entier et le transforme lui-mme en hexadcimale
            _winreg.SetValueEx(key, kname, 0, ktype, kval)
            _winreg.CloseKey(key)
        except Exception, e:
            self.log.error("erreur d'enregistrement de la variable %s (%s)"%(name, e))
            

    def remote_killproc(self, progname):
        """Tue le programme progname
        """
        self.log.info('fonction restart appelee "%s"'%progname)
        return killProcName(progname)

    def remote_winvnc(self, action, val=None, conf=None):
        """gestion VNC, actions possibles:
            - start  - restart  - start_listen  - connect
            - stop              - stop_listen   - disconnect
            - setinputs (gestion clavier/souris)
        """
        self.log.info('fonction winvnc appelee "%s"; val=%s ; conf=%s'%(action, val, conf))
        try:
            if action.lower() == 'start': self.vnc.start()
            if action.lower() == 'stop': self.vnc.stop()
            if action.lower() == 'restart': self.vnc.restart()
            if action.lower() == 'connect': self.vnc.connect(val)
            if action.lower() == 'disconnect': self.vnc.disconnect()
            if action.lower() == 'start_listen': self.vnc.start_listen(val, conf)
            if action.lower() == 'stop_listen': self.vnc.stop_listen()
            if action.lower() == 'setinputs': self.vnc.setinputs(val)
        except: pass
        self.log.info('Action %s terminee'%action)
        return True
    
    def remote_bonjour(self,old=""):
        """fonction de test
        """
        self.log.info("la fonction bonjour a ete appelee")
        return "** %s %s **"%(libelle, version)

    def remote_execute(self, command, hide=False):
        """excution  distance d'une ou d'une liste de commande(s)
        """
        # replacer WINDIR par self.windir
        if type(command) == list:
            fname = os.path.join(self.tmpdir, 'command.bat')
            try: f = file(fname,'w')
            except:
                self.log.error("Impossible d'ecrire dans %s"%fname)
                return False
            for cmd in command:
                cmd = cmd.replace('WINDIR', self.windir)
                cmd = cmd.replace('EOLEPATH', self.inst_path)
                f.write('%s\n'%cmd)
                self.log.info('Execution distante de : "%s"'%cmd)
            f.close()
            command = fname
        else:
            command = command.replace('WINDIR', self.windir)
            command = command.replace('EOLEPATH', self.inst_path)
            self.log.info('Execution distante de : "%s"'%command)
        if hide: wa.WinExec(command, wc.SW_HIDE)
        else: wa.WinExec(command)
        return True
    
    def remote_shutdown(self, bReboot=0, force=False):
        self.log.info("Extinction distante (%s)"%bReboot)
        #modification des privilges
        if int(bReboot) == 0:
            opts = wc.EWX_POWEROFF
        elif int(bReboot) == 1:
            opts = wc.EWX_REBOOT
        elif int(bReboot) == 2:
            opts = wc.EWX_LOGOFF
        if force:
            opts = opts | wc.EWX_FORCE
        wa.ExitWindowsEx(opts,0)
        return True
    
    def remote_inst_app(self, app):
        """Installe "app" depuis le msi et la ligne de commande spcifie
        app est un dictionnaire (voir backend\manage_appli.py)
        """
        init_tmpdir(self.tmpdir)
        self.log.info(u'Installation de "%(nom)s (%(titre)s)"'%(app))
        dest = self.get_file(app['exe_path'])
        if dest:
            # le dossiers menu dmarrer, bureau, etc. sont redirigs sur un lecteur rseau
            # l'utilisateur "system" ne les voit pas
            # configuration de chemin locaux dans HKEY_LOCAL_MACHINE pendant l'install
            self.save_menus()
            self.load_default_menus()
            cmd = '%s %s %s'%(app['cmd'], dest, app['args'])
            self.log.info(u'Execution de "%s"'%cmd)
            out = subprocess.call(cmd)
            self.log.info(u'Code retour de "%s" : %s'%(cmd, out))
            # puis remise des chemins "avant install"
            self.load_menus()
            return out
        else:
            return False

    def remote_bloc(self, partmod, sid, logon=False):
        """Blocage de poste, mode partage (blocage internet fait par remote_execute(ipfw ...)
        connexion  utilisateur.exe qui va monter \\scribe\perso\devoirs et redmarrer explorer.exe
        pour prendre en compte les modif regedit.
        """
        self.log.info(u'Blocage distant : partmod=%s, sid=%s, logon=%s'%(partmod, sid, logon))
        factory = pb.PBClientFactory()
        reactor.connectTCP('127.0.0.1', self.user_port, factory)
        if int(partmod) == 2:
            self.mask_part(sid)
            d = factory.getRootObject()
            d.addCallback(lambda object: object.callRemote("mount_devoir"))
        elif int(partmod) == 1:
            self.mask_part(sid)
            d = factory.getRootObject()
            d.addCallback(lambda object: object.callRemote("umount_devoir"))
        elif int(partmod) == 0:
            self.mask_part(sid, unmask=True, logon=logon)
        d = factory.getRootObject()
        return d.addCallback(lambda object: object.callRemote("restart_explorer"))
        
    ######################
    # Fonctions internes #
    ######################
    def mask_part(self, sid, unmask=False, logon=False):
        """Masque les lecteurs S:, T:, U:
        """
        kpath = r'%s\Software\Microsoft\Windows\CurrentVersion\Policies\Explorer'%sid
        hkey = _winreg.OpenKey(_winreg.HKEY_USERS, kpath)
        try: nodrives = int(_winreg.QueryValueEx(hkey, 'NoDrives')[0])
        except: nodrives = 0
        try: noview = int(_winreg.QueryValueEx(hkey, 'NoViewOnDrive')[0])
        except: noview = 0
        hkey.Close()
        # sauvegarde le configuration d'origine des lecteurs
        if logon: self.nodrives, self.noview = nodrives, noview
        if unmask: # dsactivation
            nodrives, noview = self.nodrives, self.noview
        else: # activation mode devoir
            nodrives = lecteur.add_eole_drives(nodrives)
            noview = lecteur.add_eole_drives(noview)
        self.addreg(_winreg.HKEY_USERS, kpath, _winreg.REG_DWORD, 'NoDrives', nodrives)
        self.addreg(_winreg.HKEY_USERS, kpath, _winreg.REG_DWORD, 'NoViewOnDrive', noview)
        return True
        
    def save_menus(self):
        """sauve les redirection des dossiers (Menu dmarrer, Bureau, Application Data, etc.)
        """
        key = r'HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders'
        key2 = r'HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders'
        fich = os.path.join(self.tmpdir, 'menu1.reg')
        fich2 = os.path.join(self.tmpdir, 'menu2.reg')
        self.save_reg(key, fich)
        self.save_reg(key2, fich2)
    
    def save_reg(self, keypath, fich):
        cmd = 'regedit /e "%s" "%s"'%(fich, keypath)
        wa.WinExec(cmd)
        
    def load_default_menus(self):
        """charge les chemins des dossiers (Menu Dmarrer, Bureau, etc.) par dfaut
        """
        f_menu = os.path.join(self.tmpdir, 'orig_menu.reg')
        file(f_menu, 'w').write(menu_template)
        load_reg(f_menu)
        
    def load_menus(self):
        """recharge les redirections de dossiers sauvegard par self.save_menus
        """
        fich = os.path.join(self.tmpdir, 'menu1.reg')
        fich2 = os.path.join(self.tmpdir, 'menu2.reg')
        if not os.path.exists(fich) or not os.path.exists(fich2):
            self.log.error("Impossible de restaurer les menus")
            return False
        load_reg(fich)
        load_reg(fich2)
        return True

    ##################
    # Tlchargement #
    ##################
    def get_file(self, fich):
        """tlcharge "fich" et "fich.MD5SUM" sur self.serveur
        calcul le checksum de fich et le compare  celui contenu dans "fich.MD5SUM"
        """
        try:
            file_name = os.path.basename(fich)
            dest = os.path.join(self.tmpdir, file_name)
            dest5 = '%s.MD5SUM'%dest
            url = '%s/%s'%(self.http_path, fich)
            url5 = '%s.MD5SUM'%url
            self.log.info(u'Telechargement de "%s"'%url)
            file(dest, 'wb').write(urllib2.urlopen(url).read())
            self.log.info(u'Telechargement de "%s"'%url5)
            file(dest5, 'wb').write(urllib2.urlopen(url5).read())
        except Exception, e:
            self.log.error(e)
            return None
        try:
            if self.check_sum(dest, dest5): return dest
            else: return None
        except Exception, e:
            self.log.error(e)
            return None
        
    def check_sum(self, fich, sumfich):
        """rcupre le checksum contenu dans sumfich,
        calcule le checksum de fich
        et compare les deux
        """
        orig_sum = file(sumfich, 'r').readlines()[0].strip().split()[0].strip()
        dest_sum = md5.md5(file(fich,'rb').read()).hexdigest().strip()
        if orig_sum == dest_sum:
            self.log.info('checksum OK %s'%orig_sum)
            return True
        else:
            self.log.error('orig MD5 : %s, dest MD5 : %s'%(orig_sum, dest_sum))
            return None


class gestServ:
    def __init__(self, installSignalHandlers=0):
        self.installSignalHandlers = installSignalHandlers
        # l'adresse du Scribe
        self.serveur = get_option(r'Software\Eole\Scribe','ip_scribe')
        self.serveur_port = int(get_option(r'Software\Eole\Scribe','port_scribe'))
        self.port = int(get_option(r'Software\Eole\Scribe','port_client'))
        # Variables d'environnement
        self.tmpdir = os.path.join(os.environ['TEMP'], 'Eole')
        init_tmpdir(self.tmpdir)
        self.windir = os.environ['WINDIR'] 
        # on log sur 2 fichiers de 100ko
        logfile = os.path.join(self.windir, 'cliscribe.log')
        handler = RotatingFileHandler(logfile,'a',100000,2)
        _formatter = logging.Formatter('%(asctime)s (%(process)d) %(levelname)s %(message)s')
        handler.setFormatter(_formatter)
        self.log = logging.getLogger(logfile)
        self.log.addHandler(handler)
        self.log.setLevel(logging.INFO)

    #Fonctions de dmarrage et d'arrt du service
    def servstart(self):
        # affichage du dmarrage
        self.log.info("Le service Scribe demarre : ip Scribe=%s ; port Scribe=%s ; port local=%s ; windir=%s ; tmpdir=%s"
                                                %(self.serveur, self.serveur_port, self.port, self.windir, self.tmpdir))
        # connection au serveur
        factory = pb.PBClientFactory()
        reactor.connectTCP(self.serveur, self.serveur_port, factory)
        d = factory.getRootObject()
        computer_name = wa.GetComputerName()
        #appel  la mthode "remote_service_start"
        # (enregistrement de la station comme allume)
        d.addCallback(lambda object: object.callRemote("service_start", computer_name))
        #dmarrage du serveur local quelque soit la rponse du callRemote
        d.addErrback(self.servlisten)
        d.addCallback(self.servlisten)
        reactor.run(installSignalHandlers=self.installSignalHandlers)
    
    def servlisten(self, retval):
        self.log.info('retval : %s'%retval)
        # chargement des menus par dfaut
        self.load_default_menus()
        fac = servFactory(Echoer(self))
        reactor.listenTCP(self.port, fac)

    def servstop(self):
        """Fonction d'arrt du service Scribe
        """
        # remise  l'origine des menu dmarrer et bureau communs
        # pour l'ouverture de sessions locales
        self.load_default_menus()
        # connection au serveur
        factory = pb.PBClientFactory()
        reactor.connectTCP(self.serveur, 8789, factory)
        d = factory.getRootObject()
        #appel  la mthode "remote_service_stop"
        d.addCallback(lambda object: object.callRemote("service_stop"))
        #arrt du racteur  la rponse
        d.addErrback(lambda _: reactor.stop())
        d.addCallback(lambda _: reactor.stop())
    
    def load_default_menus(self):
        """charge les chemins des dossiers (Menu Dmarrer, Bureau, etc.) par dfaut
        """
        f_menu = os.path.join(self.tmpdir, 'orig_menu.reg')
        file(f_menu, 'w').write(menu_template)
        load_reg(f_menu)

def init_tmpdir(tmpdir):
    """supprime self.tmpdir s'il existe
    le re-cre
    """
    if os.path.exists(tmpdir):
        shutil.rmtree(tmpdir)
    os.makedirs(tmpdir)
