# _*_ coding: iso-8859-1 _*_


from twisted.internet import reactor
from twisted.spread import pb



class GestApp:
    def __init__(self, serveur, port):
        self.serveur = serveur
        self.port = port
        
    ###############################
    # Gestion des appels distants #
    ###############################
    def get_apps(self, call_b, err_b):
        """demande la liste des application au serveur
        renvoie le rsultat  la fonction call_b
        ou une erreur  la fonction err_b
        """
        factory = pb.PBClientFactory()
        reactor.connectTCP(self.serveur, self.port, factory)
        d = factory.getRootObject()
        d.addCallback(lambda object: object.callRemote("get_apps"))
        d.addCallback(call_b)
        d.addErrback(err_b,("Impossible de se connecter au serveur"))
##        d.addErrback(err_b,("Impossible de se connecter au serveur"))
    
    def inst_app(self, app, call_b, err_b):
        """installe app sur la station
        app = id de l'application
        """
        factory = pb.PBClientFactory()
        reactor.connectTCP(self.serveur, self.port, factory)
        d = factory.getRootObject()
        d.addCallback(lambda object: object.callRemote("inst_app",(app)))
        d.addCallback(call_b, (app))
        d.addErrback(err_b,("Impossible de se connecter au serveur"))
        d.addErrback(err_b,("Impossible de se connecter au serveur"))

    def lance_app(self, app, call_b, err_b):
        """Lance "app" suivant les paramtres fournis dans la configuration de "app"
        """
        factory = pb.PBClientFactory()
        reactor.connectTCP(self.serveur, self.port, factory)
        d = factory.getRootObject()
        d.addCallback(lambda object: object.callRemote("lance_app",(app)))
        d.addCallback(call_b, (app))
        d.addErrback(err_b,("Impossible de se connecter au serveur"))
